import pygame, sys, os, random
from pygame.locals import *

pygame.init()

class window:
	def __init__(self,size):	#size is a tuple
		self.size=size
		self.fullscreen=False
		self.display=pygame.display.set_mode(self.size)
		pygame.display.set_caption('The nemesis code')
		try:
			pygame.display.set_icon(pygame.image.load('data/images/misc/icon.png'))
		except:
			print 'No icon file.'
		self.surface=pygame.Surface(size)
		self.fullscreen=False
		
	def update(self):
		self.display.blit(self.surface, (0,0))
		pygame.display.update()
		
		#reset
		self.surface.fill((0,0,0))
		
	def toggle_fullscreen(self):
		self.fullscreen=not self.fullscreen
		if self.fullscreen==True:
			self.display=pygame.display.set_mode(self.size,pygame.FULLSCREEN)
		else:
			self.display=pygame.display.set_mode(self.size)
		
class player:
	def __init__(self,name,buttons):	#buttons is a list of key events, [jump]
		self.pos=[100,0]
		self.score=0
		self.buttons=buttons
		images_get=['j','1','2','3','4']
		self.images=[]
		for i in images_get:
			image=pygame.image.load('data/images/'+name+'/'+i+'.png')
			image2=pygame.transform.scale(image, (image.get_width()*2,image.get_height()*2))
			image2.set_colorkey((255,255,255))
			self.images.append(image2)
		self.image=self.images[1]
		self.image_number=1
		self.rect=pygame.Rect(self.pos[0],self.pos[1],self.image.get_width(),self.image.get_height())
		self.feet_rect=pygame.Rect(self.pos[0],self.pos[1]+60,self.image.get_width(),3)
		self.jump=0
		self.tick=0
		self.falling=False
		
	def update(self):
		#test event
		for event in Game.events:
			if event.type==KEYDOWN:
				if event.key==self.buttons[0]:
					if self.falling==False:
						self.jump+=1
					
			if event.type==KEYUP:
				if event.key==self.buttons[0]:
					self.jump==0
					
		#set image
		if self.tick%25==0:
			if self.jump>0 or self.falling==True:
				self.image=self.images[0]
			else:
				self.image_number+=1
				self.image_number=self.image_number%4
				self.image=self.images[self.image_number+1]
			
			self.rect[2]=self.image.get_width()
			self.rect[3]=self.image.get_height()	
				
		#set rect
		self.rect[0]=self.pos[0]
		self.rect[1]=self.pos[1]
		
		self.feet_rect[1]=self.pos[1]+60
		
		#physics
		if self.tick%1==0:
			self.rect[1]+=1
			collide=False
			for i in Game.level.templates:
				for j in i:
					if self.feet_rect.colliderect(j.pos)==True and j.tile_type=='platform':
						collide=True
			if collide==True:
				self.rect[1]-=1
				self.falling=False
			else:
				self.pos[1]+=1
				self.falling=True
				
			if self.jump>0:
				self.pos[1]-=2
				self.jump+=1
				if self.jump>70:
					self.jump=0
	
		#test for death
		if self.pos[1]>512:
			game_over('fall')
			
		for i in Game.level.templates:
			for j in i:
				if self.rect.colliderect(j.pos)==True and j.tile_type=='firewall':
					game_over('firewall')
					
		for i in Game.level.enemies:
			if self.rect.colliderect(i.rect)==True:
					game_over('antivirus')

		#draw
		Window.surface.blit(self.image,self.rect)
		
		self.tick+=1
		
class antivirus:
	def __init__(self, name):
		self.pos=[random.randint(1000,2000),432]
		images_get=['1','2']
		self.images=[]
		for i in images_get:
			image=pygame.image.load('data/images/'+name+'/'+i+'.png')
			image2=pygame.transform.scale(image, (image.get_width()*2,image.get_height()*2))
			image2.set_colorkey((255,255,255))
			self.images.append(image2)
		self.image=self.images[0]
		self.image_number=0
		self.rect=pygame.Rect(self.pos[0],self.pos[1],self.image.get_width(),self.image.get_height())	
		self.tick=0
			
	def update(self):
		
		#set image
		if self.tick%25==0:
			self.image_number+=1
			self.image_number=self.image_number%2
			self.image=self.images[self.image_number]
			
			self.rect[2]=self.image.get_width()
			self.rect[3]=self.image.get_height()	
				
		#set rect
		self.pos[0]-=2
		self.rect[0]=self.pos[0]
		self.rect[1]=self.pos[1]
		
		if self.pos[0]<0-self.rect[2]:
			self.pos[0]=random.randint(1000,5000)
		
		#draw
		Window.surface.blit(self.image,self.rect)
		
		self.tick+=1

images=[]
for i in range(0,10):
	image=pygame.image.load('data/images/levels/'+str(i)+'.png')
	image.set_colorkey((255,255,255))
	images.append(image)		

def get_template(number,x_pos):
	f=file('data/templates/'+str(number)+'.txt','r')
	data=f.read()
	f.close()
	tiles=[]
	for i in range(32):
		sub_tiles=[]
		for j in range(32):
			sub_tiles.append(data[i*32+j])
		tiles.append(sub_tiles)
		
	tileset=[]

	for i in range(len(tiles)):
		for j in range(len(tiles[i])):
			current_tile=tiles[i][j]
			if current_tile != ' ':
				if current_tile == '0':
					tileset.append(tile('platform',images[0],pygame.Rect(i*16+x_pos,j*16,16,16)))
				else:
					tileset.append(tile('firewall',images[int(current_tile)],pygame.Rect(i*16+x_pos,j*16,16,16)))		
	return tileset
		
class tile:
	def __init__(self,tile_type,image,pos):
		self.pos=pos
		self.tile_type=tile_type
		self.image=image
		
	def update(self):
		Window.surface.blit(self.image,self.pos)

class score:
	def __init__(self,highscore_file):
		self.filename=highscore_file
		self.score=0
		f=file(self.filename, 'r')
		self.highscore=int(f.read())
		f.close()
		self.font=pygame.font.Font('data/acknowtt.ttf', 18)
		self.tick=0
		
	def update(self):
		if self.tick>200:
			if self.tick%200==0:
				self.score+=1
				
		if self.score>self.highscore:
			self.highscore=self.score
	
		self.text=text('downloaded:  '+str(self.score)+' kb',self.font,(10,0),(34,177,76))
		self.htext=text('maximum downloaded:  '+str(self.highscore)+' kb',self.font,(10,10),(34,177,76))
		
		self.text.update()
		self.htext.update()
		
		self.tick+=1
	
	def save(self):
		f=file(self.filename, 'w')
		f.write(str(self.highscore))
		f.close()
		
class text:
	def __init__(self,string,font,pos,color):
		self.text=font.render(string, True, color, (0,0,0))
		self.rect=self.text.get_rect()
		self.rect.topleft=pos
		
		self.text.set_colorkey((0,0,0))
		
	def update(self):
		Window.surface.blit(self.text,self.rect)
		
class message:
	def __init__(self,lines):
		self.font=pygame.font.Font('data/acknowtt.ttf', 18)
		self.lines=[]
		for i in range(len(lines)):
			self.lines.append(text(lines[i],self.font,(10,i*10+30),(34,177,76)))
			
	def update(self):
		for i in self.lines:
			i.update()
					
class level:
	def __init__(self):
		self.scroll=0
		self.templates=[get_template(1,0),get_template(1,512)]
		self.enemies=[]
		
	def update(self):
		for i in self.templates:
			for j in i:
				j.pos[0]-=1
					
		self.scroll+=1
						
		if self.scroll == 512:
			self.scroll=0
			self.templates[0]=self.templates[1]
			self.templates[1]=get_template(random.randint(1,8),512)	#change for more templates
	
		for i in self.templates:
			for j in i:
				j.update()
				
		for i in self.enemies:
			i.update()
				
	def add_enemies(self):
		self.enemies.append(antivirus('antivirus'))
						
class game:
	def __init__(self):
		self.player=player('player',[K_UP])
		self.clock=pygame.time.Clock()
		self.difficulty=150	#frames per second 
		self.level=level()
		self.score=score('data/highscore.pck')
		self.current_message=1
		f=file('data/messages/'+str(self.current_message)+'.pck', 'r')
		lines=f.read().split(',')
		f.close()
		self.message=message(lines)
		self.events=pygame.event.get()
		self.tsi=pygame.time.get_ticks() #time since initialize
		if Music.playing==True:
			Music.play()
		
	def loop(self):
		while True:
			#events
			self.events=pygame.event.get()
			for event in self.events:
				if event.type==QUIT:
					self.quit()
			
				if event.type==KEYUP:
					if event.key==K_ESCAPE:
						self.quit()
						
				if event.type==KEYDOWN:
					if event.key==K_F1:
						options()		
						if Music.playing==True:
								Music.play()
						else:
							Music.stop()
									
					if event.key==K_F2:
						Window.toggle_fullscreen()
						
					if event.key==K_F3:
						if Music.possible==True: 
							Music.toggle_playing()
							if Music.playing==True:
								Music.play()
							else:
								Music.stop()
		
			self.level.update()
			self.player.update()
			self.score.update()
			self.message.update()
			Window.update()
			self.clock.tick(self.difficulty)
			
			if (pygame.time.get_ticks()-self.tsi)%(difficultyfactor*1000)==0:
				self.difficulty+=1
				
			if (pygame.time.get_ticks()-self.tsi)%(difficultyfactor*1000000)==0:
				self.level.add_enemies()
				
			if (pygame.time.get_ticks()-self.tsi)%(100000)==0:
				self.current_message+=1
				try:
					f=file('data/messages/'+str(self.current_message)+'.pck', 'r')
					lines=f.read().split(',')
					f.close()
					self.message=message(lines)
				except:
					print 'no more messages'
						
	def quit(self):
		pygame.quit()
		sys.exit()

def game_over(death):
	Window.update()
	if death == 'fall':
		exception = '>>Fell through a hole in cyberspace_deleted'
	if death == 'firewall':
		exception = '>>Ran into firewall_deleted'
	if death == 'antivirus':
		exception = '>>.Detected by antivirus_deleted'

	Message=message([exception,'','GAME OVER!','','<press any key>'])
	Game.score.save()		
	
	Game.level.update()
	Window.surface.blit(Game.player.image,Game.player.rect)
	Game.score.update()
	Message.update()
	Window.update()

	while True:	
		for event in pygame.event.get():
			if event.type==QUIT:
				Game.quit()
		
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					Game.quit()	
					
			if event.type==KEYDOWN:
				if event.key==K_F1:
					options()		
					if Music.playing==True:
						Music.play()
					else:
						Music.stop()
								
				if event.key==K_F2:
					Window.toggle_fullscreen()
					
				if event.key==K_F3:
					if Music.possible==True: 
						Music.toggle_playing()
						if Music.playing==True:
							Music.play()
						else:
							Music.stop()
				
				Music.stop()			
				menu()	

class button:
	def __init__(self,y,text):
		self.string=text
		self.font=pygame.font.Font('data/acknowtt.ttf', 25)	
		self.pos=(10,y)
		
	def update(self,highlighted):
		self.string_highlighted='>'+self.string
		if highlighted==True:
			string=self.string_highlighted
		else:
			string=self.string
		self.text=text(string,self.font,self.pos,(34,177,76))
		self.text.update()	
					
def menu():
	global Game
	strings=['PLAY','INTRO','CREDITS','OPTIONS','QUIT']
	heading=text('The Nemisis Code',pygame.font.Font('data/acknowtt.ttf', 35),(10,10),(34,177,76))
	buttons=[]
	for i in range(len(strings)):
		buttons.append(button(20*i+40,strings[i]))
	index=0
	
	while True:
		for event in pygame.event.get():
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
		
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
					
			if event.type==KEYDOWN:
				if event.key==K_UP:
					index-=1
				
				if event.key==K_DOWN:
					index+=1
					
				index=index%len(buttons)
				
				if event.key==K_RETURN:
					if index==0:
						Game=game()
						Game.loop()
					
					if index==1:
						story('intro')	
						
					if index==2:
						story('credits')	
						
					if index==3:
						options()	
							
					if index==4:	#change for more items in menu
						pygame.quit()
						sys.exit()
				
				if event.key==K_F1:
					options()		
								
				if event.key==K_F2:
					Window.toggle_fullscreen()
					
				if event.key==K_F3:
					if Music.possible==True: 
						Music.toggle_playing()
		
		heading.update()
		
		for i in range(len(buttons)):
			if i==index:
				buttons[i].update(True)
			else:
				buttons[i].update(False)
				
		Window.update()						

def options():
	strings=['FULLSCREEN','MUSIC','VOLUME','BACK']
	heading=text('Options',pygame.font.Font('data/acknowtt.ttf', 35),(10,10),(34,177,76))
	buttons=[]
	volume=pygame.mixer.music.get_volume()
	for i in range(len(strings)):
		buttons.append(button(20*i+40,strings[i]))
	index=0
	
	while True:
		for event in pygame.event.get():
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
		
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
					
			if event.type==KEYDOWN:
				if event.key==K_UP:
					index-=1
				
				if event.key==K_DOWN:
					index+=1
				
				if index==2:
					if event.key==K_RIGHT:
						volume+=0.1
						
					if event.key==K_LEFT:
						volume-=0.1
						
					volume=volume%1.0
					try:
						pygame.mixer.music.set_volume(volume)
					except:
						print 'No music'
							
				index=index%len(buttons)
				
				if event.key==K_RETURN:					
					if index==0:
						Window.toggle_fullscreen()	
						
					if index==1:
						if Music.possible==True: 
							Music.toggle_playing()		
							
					if index==3:
						return
				
				if event.key==K_F1:
					return		
								
				if event.key==K_F2:
					Window.toggle_fullscreen()
					
				if event.key==K_F3:
					if Music.possible==True: 
						Music.toggle_playing()
		
		heading.update()
		
		if Window.fullscreen==True:
			buttons[0].string='FULLSCREEN on'
		else:
			buttons[0].string='FULLSCREEN off'
		
		if Music.possible==True:	
			if Music.playing==True:
				buttons[1].string='MUSIC on'
			else:
				buttons[1].string='MUSIC off'
		else:
			buttons[1].string='MUSIC off'
		
		buttons[2].string='VOLUME '+str(volume*10)
		
		for i in range(len(buttons)):				
			if i==index:
				buttons[i].update(True)
			else:
				buttons[i].update(False)
				
		Window.update()							
		
def story(file_name):
	f=file('data/'+file_name+'.pck', 'r')
	strings=f.read().split(',')
	f.close()
	lines=[]
	for i in range(len(strings)):
		if strings[i][0]=='#':
			lines.append(type_line(strings[i][1:],i*20+20))
		else:
			lines.append(print_line(strings[i][1:],i*20+20,int(strings[i][0])))
	current_line=1
	clock=pygame.time.Clock()
	
	#loop
	while True:
		for i in range(current_line):
			finished=lines[i].update()
			if finished==True and i == current_line-1:
				current_line+=1
				
		for event in pygame.event.get():
			if event.type==QUIT:
				pygame.quit()
				sys.exit()
		
			if event.type==KEYUP:
				if event.key==K_ESCAPE:
					pygame.quit()
					sys.exit()
					
			if event.type==KEYDOWN:	
				if event.key==K_F1:
					options()		
								
				if event.key==K_F2:
					Window.toggle_fullscreen()
					
				if event.key==K_F3:
					if Music.possible==True: Music.toggle_playing()
						
				return
		
		Window.update()	
		
		clock.tick(100)	
		
		if current_line==len(lines)+1:
			return
				
class type_line:
	def __init__(self,text,y):
		self.full_text=text
		self.pos=(10,y)
		self.font=pygame.font.Font('data/acknowtt.ttf', 25)	
		self.index=0
		self.tick=0
		
	def update(self):
		if self.tick%(5*3)==0:
			self.text=text(self.full_text[:self.index]+'_',self.font,self.pos,(34,177,76))
			self.index+=1
		self.text.update()

		self.tick+=1
		
		if self.index==len(self.full_text)+1:
			return True
		else:
			return False

class print_line:
	def __init__(self,string,y,wait):	#wait is in secconds
		self.pos=(10,y)
		self.font=pygame.font.Font('data/acknowtt.ttf', 25)	
		self.text=text(string,self.font,self.pos,(34,177,76))				
		self.wait=wait
		self.tick=0
		
	def update(self):
		self.text.update()
		self.tick+=1
		
		if self.tick==self.wait*100:
			return True
		else:
			return False

class music:
	def __init__(self,file_name):
		try:
			pygame.mixer.music.load('data/'+file_name)				
			pygame.mixer.music.set_volume(0.5)
			self.possible=True
			self.playing=True
		except:
			self.possible=False
		
	def toggle_playing(self):
		if self.possible==True:
			self.playing=not self.playing
				
	def play(self):
		if self.possible==True:
			pygame.mixer.music.play(-1)
		
	def stop(self):
		if self.possible==True:
			pygame.mixer.music.stop()
		
difficultyfactor=1		
Window=window((512,512))
Music=music('music.wav')
pygame.mouse.set_visible(False)
story('intro')		
menu()